/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_EFIL                                                     */
/* Tabela : ENDEFILI                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 18/06/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/


CREATE OR REPLACE TRIGGER DTULTATU_EFIL
BEFORE INSERT OR UPDATE OR DELETE
ON ENDEFILI FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUEFIL := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.SGESTADO,0)     <> NVL(:NEW.SGESTADO,0))     OR
         (NVL(:OLD.DSENDEFILI,0)   <> NVL(:NEW.DSENDEFILI,0))   OR
         (NVL(:OLD.NMBAIRFILI,0)   <> NVL(:NEW.NMBAIRFILI,0))   OR
         (NVL(:OLD.NRCEPFILI,0)    <> NVL(:NEW.NRCEPFILI,0))    OR
         (NVL(:OLD.NRTELEFILI,0)   <> NVL(:NEW.NRTELEFILI,0))   OR
         (NVL(:OLD.NRFAXFILI,0)    <> NVL(:NEW.NRFAXFILI,0))    OR
         (NVL(:OLD.CDPAIS,0)       <> NVL(:NEW.CDPAIS,0))       OR
         (NVL(:OLD.CDMUNICIPIO,0)  <> NVL(:NEW.CDMUNICIPIO,0))  OR
         (NVL(:OLD.IDTPENDEFILI,0) <> NVL(:NEW.IDTPENDEFILI,0)) OR
         (NVL(:OLD.CDSENHEMAILF,0) <> NVL(:NEW.CDSENHEMAILF,0)) OR
         (NVL(:OLD.DSSMTPEMAILF,0) <> NVL(:NEW.DSSMTPEMAILF,0)) OR
         (NVL(:OLD.DSEMAILFILI,0)  <> NVL(:NEW.DSEMAILFILI,0))  THEN
         :NEW.DTULTATUEFIL := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('ENDEFILI', :OLD.CDFILIAL, 'CDFILIAL='||:OLD.CDFILIAL||';IDTPENDEFILI='||:OLD.IDTPENDEFILI||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE ENDEFILI MODIFY DTULTATUEFIL DEFAULT SYSDATE
/

UPDATE ENDEFILI SET DTULTATUEFIL = SYSDATE WHERE DTULTATUEFIL IS NULL
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_EFIL','4.11.210'); END;
/

