/* Sistemas Integrados TEKNISA
  Controle de Produo

Nome: 3931_CDPSTPO.SQL

Descrio:
Calcula periodicidade de produo para dias da semana.

P_CDFILIAL     - Cdigo da Filial.
P_CDPERIPRODU  - Cdigo da Periodicidade de Produo.
P_DTINICIAL    - Data inicial a ser gerado o clculo.
P_IDDIANUTIL   - Indicador de utilizao de dia no til para produo.
P_DTPROCESSA   - Data de Processamento da Filial.

PARA DEBUGAR
-- SET SERVEROUTPUT ON
-- DBMS_OUTPUT.PUT_LINE('xx');

Criao:
03/09/2004 - Fabrcio Marcelo da Silva
*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'PERIPRODUCAO_SEMANAL'  and
            type = 'P'                       and
            u.uid = o.uid                    and
            u.name = USER)
  DROP PROCEDURE PERIPRODUCAO_SEMANAL
  GO

CREATE PROCEDURE PERIPRODUCAO_SEMANAL
   @P_CDFILIAL      VARCHAR(4),
   @P_CDPERIPRODU   VARCHAR(2),
   @P_DTINICIAL     DATETIME,
   @P_IDDIANUTIL    VARCHAR(1),
   @P_DTPROCESSA    DATETIME
AS
   DECLARE @V_CONTAUXI     INT;
   DECLARE @V_DIPRODUCAO   INT;
   DECLARE @V_DTDIAPRODU   DATETIME;
   DECLARE @V_IDDIASEM     INT;
   DECLARE @V_JAEXISTE     NUMERIC(10);   

   /*-- CURSOR QUE CONTEM AS DATAS DE PRODUCAO NO MES COM BASE NOS DIAS DE PRODUCAO SEMANAIS --*/
   DECLARE C_DATAS_PRODU CURSOR FOR
      SELECT
         CONVERT(INT,DIPRODUCAO),
         1 AS OCORR
       FROM DIASPRODUCAO
       WHERE
         CDPERIPRODU = @P_CDPERIPRODU AND
         IDOCORP01 = '1'
      UNION
      SELECT
        CONVERT(INT,DIPRODUCAO),
        2  AS OCORR
      FROM DIASPRODUCAO
        WHERE
         CDPERIPRODU = @P_CDPERIPRODU AND
         IDOCORP02 = '1'
      UNION
      SELECT
        CONVERT(INT,DIPRODUCAO),
        3  AS OCORR
      FROM DIASPRODUCAO
      WHERE
        CDPERIPRODU = @P_CDPERIPRODU AND
        IDOCORP03 = '1'
      UNION
      SELECT
        CONVERT(INT,DIPRODUCAO),
        4 AS OCORR
      FROM DIASPRODUCAO
      WHERE
        CDPERIPRODU = @P_CDPERIPRODU AND
        IDOCORP04 = '1'
      UNION
      SELECT
        CONVERT(INT,DIPRODUCAO),
        5 AS OCORR
      FROM DIASPRODUCAO
      WHERE
        CDPERIPRODU = @P_CDPERIPRODU AND
        IDOCORP05 = '1'
      ORDER BY 2;
BEGIN
   SET @V_CONTAUXI   = 0;
   SET @V_DTDIAPRODU = @P_DTINICIAL;

   OPEN C_DATAS_PRODU;
   FETCH NEXT FROM C_DATAS_PRODU INTO @V_DIPRODUCAO, @V_IDDIASEM;
   WHILE (@@FETCH_STATUS = 0)
   BEGIN
      IF @V_IDDIASEM <> 5 BEGIN
         SET @V_DTDIAPRODU = @P_DTINICIAL - 1;
      END;
      SET @V_DTDIAPRODU = DATEADD(MM, 1, @V_DTDIAPRODU) - DAY(DATEADD(MM, 1, @V_DTDIAPRODU));/*LAST_DAY*/
      IF @V_IDDIASEM = 5 BEGIN
         SET @V_DTDIAPRODU = @V_DTDIAPRODU - 7;
         EXEC PROXIMO_DIA @V_DIPRODUCAO,1,@P_DTPROXIMA = @V_DTDIAPRODU OUTPUT;
      END
      ELSE BEGIN
         EXEC PROXIMO_DIA @V_DIPRODUCAO,@V_IDDIASEM,@P_DTPROXIMA = @V_DTDIAPRODU OUTPUT;
      END;

      /* Verifica se o dia e util */
      SELECT
         @V_CONTAUXI = COUNT(*)
      FROM
         FERICOMP
      WHERE
         CDFILIAL   = @P_CDFILIAL    AND
         DTFERICOMP = @V_DTDIAPRODU;

     IF ((@P_IDDIANUTIL = 'S') AND (@V_CONTAUXI = 0)) OR
         (@P_IDDIANUTIL = 'N')                        BEGIN

         SET @V_JAEXISTE = 0;
         SELECT @V_JAEXISTE = COUNT(*)
         FROM CALEPRODUCAO
         WHERE
            CDFILIAL    = @P_CDFILIAL     AND
            CDPERIPRODU = @P_CDPERIPRODU  AND
            DTPRODUCAO  = @V_DTDIAPRODU;

         IF (@V_JAEXISTE = 0) BEGIN

            /*- INCLUI A DATA DE ENTREGA CALCULADA NO CALENDARIO DE PRODUCAO -*/
            INSERT INTO CALEPRODUCAO
               (CDFILIAL,
                CDPERIPRODU,
                DTPRODUCAO)
            VALUES
               (@P_CDFILIAL,
                @P_CDPERIPRODU,
                @V_DTDIAPRODU);
         END;
      END;
      FETCH NEXT FROM C_DATAS_PRODU INTO @V_DIPRODUCAO, @V_IDDIASEM;
   END;
   CLOSE C_DATAS_PRODU;
   DEALLOCATE C_DATAS_PRODU;
END
GO
