/******************************************************************************/
/* TEKNISA                                                                    */
/******************************************************************************/
/*                                                                            */
/* NOME: INSERE_SERVICO_AGREGADA                                              */
/*                                                                            */
/* DESCRIO:                                                                 */
/*   Insere o servio utilizado na retirada para a agregada.                  */
/*                                                                            */
/* CRIAO:                                                                   */
/*   17/02/2006 - Rafael Christopher de Souza e Silva                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'INSERE_SERVICO_AGREGADA'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER INSERE_SERVICO_AGREGADA
GO

CREATE TRIGGER INSERE_SERVICO_AGREGADA
ON CARDADIA
FOR INSERT
AS
   DECLARE @V_CONTSERV     INT;
   DECLARE @V_CDFILCENTPME VARCHAR(4);
   DECLARE @V_CDFILIAL     VARCHAR(4);
   DECLARE @V_NMSERVICO    VARCHAR(40);
   DECLARE @V_CDSERVFILI   VARCHAR(5);
BEGIN
   DECLARE C_CURSOR CURSOR FOR
      SELECT
         CDFILIAL,
         CDSERVFILI
      FROM
         INSERTED
      WHERE
         (0 = (SELECT COUNT(*) FROM INSERTED));

      OPEN C_CURSOR;
      FETCH NEXT FROM C_CURSOR INTO @V_CDFILIAL,
                                    @V_CDSERVFILI;

   WHILE (@@FETCH_STATUS = 0)
   BEGIN
      SELECT
         @V_CDSERVFILI = MAX(CDSERVFILI)
      FROM
         SERVICO
      WHERE
         (CDFILIAL   = @V_CDFILIAL)   AND
         (CDSERVFILI = @V_CDSERVFILI);

      IF (@V_CDSERVFILI IS NULL)
      BEGIN
         /*Retorna a central da agregada*/
         SELECT
            @V_CDFILCENTPME = MAX(CDFILCENTPME)
         FROM
            FILIAL
         WHERE
            (CDFILIAL = @V_CDFILIAL);

         IF NOT(@V_CDFILCENTPME IS NULL)
         BEGIN
            /*Retorna a nome do servico*/
            SELECT
               @V_NMSERVICO = MAX(NMSERVICO)
            FROM
               SERVICO
            WHERE
               (CDFILIAL   = @V_CDFILCENTPME) AND
               (CDSERVFILI = @V_CDSERVFILI);

            IF NOT(@V_NMSERVICO IS NULL)
            BEGIN
               INSERT INTO SERVICO
               (CDFILIAL, CDSERVFILI, NMSERVICO, IDTIPOSERV)
               (SELECT CDFILIAL, CDSERVFILI, @V_NMSERVICO, 'M' FROM INSERTED)
            END;
         END;
      END;
      FETCH NEXT FROM  C_CURSOR INTO @V_CDFILIAL,
                                     @V_CDSERVFILI;
   END;
   CLOSE C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'INSERE_SERVICO_AGREGADA','4.11.022';
GO
