/*---------------------------------------------------------+
+ PROCEDURE  CRIA_FATOS_DRILL                              +
+ FUNO: CRIAO DE FATOS DE DRILL NA BASE DE DADOS       +
+                                                          +
+ CRIAO: 15/11/2007                                      +
+ RAPHAEL ERNANI RODRIGUES                                 +
+                                                          +
+---------------------------------------------------------*/
IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'CRIA_FATOS_DRILL' AND
	        TYPE = 'P' 	               AND
	        U.UID = O.UID               AND
	        U.NAME = USER)
	DROP PROCEDURE CRIA_FATOS_DRILL
GO

create PROCEDURE CRIA_FATOS_DRILL @P_CDTABDRILL  VARCHAR(30),
                                  @P_CDITEMDRILL VARCHAR(30),
                                  @P_NMITEMDRILL VARCHAR(30)
AS
   DECLARE   @V_COUNT       INT;
   DECLARE   @V_COUNT2      INT;
   DECLARE   @V_NMITEMDRILL VARCHAR(30);
   DECLARE   @V_TRY         INT;
BEGIN
   BEGIN TRAN;
   SET @V_TRY = 0;   

   SELECT @V_COUNT = COUNT(*)
   FROM ITEMDRILL
   WHERE CDITEMDRILL = @P_CDITEMDRILL
     AND CDTABDRILL  = @P_CDTABDRILL;

   IF @V_COUNT=0
   BEGIN  
      SET @V_NMITEMDRILL = @P_NMITEMDRILL;
      SET @V_COUNT    = 1; -- O SISTEMA DEVE ENTRAR NO LOOP PELO MENOS UMA VEZ

      WHILE @V_COUNT <> 0
      BEGIN 
         SELECT @V_COUNT = COUNT(*)
         FROM   ITEMDRILL
         WHERE  NMITEMDRILL = @V_NMITEMDRILL;
         IF @V_COUNT=0
         BEGIN
            SELECT @V_COUNT2 = COUNT(*) 
            FROM TABELADW
            WHERE CDTABELADW = @P_CDTABDRILL;
            IF @V_COUNT2=0
            BEGIN
               INSERT INTO TABELADW 
               (CDTABELADW, NMTABELADW, IDDRILLDOWN) 
               VALUES
               (@P_CDTABDRILL, @P_CDTABDRILL , 'S');
            END;
            
            
            INSERT INTO ITEMDRILL
            (CDTABDRILL,    CDITEMDRILL,    NMITEMDRILL,   IDTPFATODRILL)
            VALUES
            (@P_CDTABDRILL, @P_CDITEMDRILL, @V_NMITEMDRILL,'M');
         END
         ELSE
         BEGIN
            IF LEN(@V_NMITEMDRILL+CAST(@V_TRY AS VARCHAR))<=30 
            BEGIN
               SET @V_NMITEMDRILL = @V_NMITEMDRILL+CAST(@V_TRY AS VARCHAR);
            END
            ELSE
            BEGIN
               SET @V_TRY      = @V_TRY + 1;
               SET @V_NMITEMDRILL = @P_NMITEMDRILL;
               IF LEN(@V_NMITEMDRILL+CAST(@V_TRY AS VARCHAR))>=30
               BEGIN
                  SET @V_COUNT = 0;
               END;
            END;
         END;   
      END; -- LOOP
   END;
   COMMIT TRAN;
END
GO


--VERSAO--
EXEC ATUVEROBJ'CRIA_FATOS_DRILL','5.01.000';
GO

-- VERSAO --
EXEC ATUVEROBJ 'CRIA_FATOS_DRILL','5.01.004';
GO

